<?php
/*
Plugin Name: List Event Post Type
Plugin URI: http://www.johanronstrom.se/2013/03/04/list-event-post-type-wordpress-widget-plugin/
Description: Lists posts of custom post type "events" with meta fields "event_date" and "event_venue". (HTML5 only)
Version: 0.1
Author: Johan Ronström
Author URI: http://johanronstrom.se
*/

error_reporting(E_ALL);
add_action("widgets_init", array('list_event_post_type', 'register'));
class list_event_post_type {

	function control(){

		$data = get_option('list_event_post_type');

		?>
		<p><label>Title<input class="widefat" name="list_event_post_type_title"
		type="text" value="<?php echo stripslashes($data['title']); ?>" /></label></p>
		<p><label>Number of posts<input class="widefat" name="list_event_post_type_amount"
		type="text" value="<?php echo stripslashes($data['amount']); ?>" /></label></p>
		<p><label>Markup<textarea name="list_event_post_type_markup" cols="20" rows="16" class="widefat"><?php echo stripslashes($data['markup']); ?></textarea></label></p>

		<?php
		if (isset($_POST['list_event_post_type_title'])){
			$data['title'] = attribute_escape($_POST['list_event_post_type_title']);
			$data['amount'] = (int)attribute_escape($_POST['list_event_post_type_amount']);
			$data['markup'] = attribute_escape($_POST['list_event_post_type_markup']);
			update_option('list_event_post_type', $data);
		}
	}


	function widget($args){

		$data = get_option('list_event_post_type');

		echo $args['before_widget'];
		echo $args['before_title'] . $data['title'] . $args['after_title'];

		echo '<ul class="list_event_post_type">';		

        query_posts( array( 
              'post_type'   => 'events',      // only query events
              'meta_key'    => 'event_date',  // load up the event_date meta
              'orderby'     => 'meta_value',  // sort by the event_date
              'order'       => 'asc',         // ascending, so earlier events first
              'posts_per_page' => $data['amount'],
              'meta_query'  => array(		  // restrict posts based on meta values
								array (		  // meta_query exepcts nested arrays
								  'key'     => 'event_date',  // which meta to query
								  'value'   => date("Ymd"),   // value for comparison (today)
								  'compare' => '>=',          // method of comparison
								  'type'    => 'NUMERIC'      // datatype, we don't want to compare the string values
								)			  // end nested array
				) // end meta_query array

              ) // end array
            ); // close query_posts call


		// The Loop
		while ( have_posts() ) : the_post();

			print '<li>';

			$output = stripslashes($data['markup']);

				// replace [date xx] with event date in "xx" dateformat
			$eventDate = strtotime(get_post_meta(get_the_ID(), 'event_date', true));
			$output = preg_replace_callback('/\[date (.*?)]/', function($matches) use($eventDate)
															   {
																	return date($matches[1],$eventDate);
															   }, $output);

				// replace [title], [venue] and [link]
			$eventTitle = get_the_title();
			$eventVenue = get_post_meta(get_the_ID(), 'event_venue', true);
			$eventLink = get_permalink();
			$replacePattern = array( '/\[title\]/',
									 '/\[venue\]/',
									 '/\[link\]/');
			$replaceReplacement = array($eventTitle, $eventVenue, $eventLink);
			$output = preg_replace($replacePattern, $replaceReplacement, $output);


			
			print html_entity_decode($output);

			print '</li>';

		endwhile;

		// Reset Query
		wp_reset_query();
		?>
		</ul>
		<?php


		echo $args['after_widget'];
	}


	function register(){
		register_sidebar_widget('List Event Post Type', array('list_event_post_type', 'widget'));
		register_widget_control('List Event Post Type', array('list_event_post_type', 'control'));
	}
}


?>